<script lang="ts">
export default {
    data(): any {
        return {
            clients: [],
            loading: true
        }
    },
    async mounted() {
        this.getClients();
    },
    methods: {
        async deleteClient(id: number) {
            await fetch('http://localhost:8000/api/clients/' + id, {
                method: 'DELETE',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            this.getClients();
        },
        async getClients() {
            const response = await fetch('http://localhost:8000/api/clients', {
                method: 'GET',
                headers: {
                    'Content-Type': 'application/json',
                }
            });
            const responseData = await response.json();
            this.clients = responseData['hydra:member'];
            this.loading = false;
        }
    }
};

</script>

<template>
    <v-row align="center">
        <v-col cols="12" lg="3">
            <h1>Liste des clients</h1>
        </v-col>

        <v-col cols="12" lg="7">
            <v-btn to="/clients/create" color="primary" variant="outlined">Créer un client</v-btn>
        </v-col>

        <v-col cols="12">
            <v-row>
                <v-col cols="12" lg="12">

                    
                    <v-card elevation="10" class="">
                        <v-card-item class="py-2 px-4">
                            <v-table class="month-table">
                                <thead>
                                    <tr>
                                        <th class="text-subtitle-1 font-weight-bold">Id</th>
                                        <th class="text-subtitle-1 font-weight-bold">Nom</th>
                                        <th class="text-subtitle-1 font-weight-bold">Adresse</th>
                                        <th class="text-subtitle-1 font-weight-bold">E-mail</th>
                                        <th class="text-subtitle-1 font-weight-bold">Téléphone</th>
                                        <th class="text-subtitle-1 font-weight-bold text-right"></th>
                                    </tr>
                                </thead>
                                <tbody v-if="!loading">
                                    <tr v-for="item in clients" :key="item.name" class="month-item">
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ item.id }}</p>
                                        </td>
                                        <td>
                                            <div class="">
                                                <h6 class="text-subtitle-1 font-weight-bold">{{ item.nom }}</h6>
                                            </div>
                                        </td>
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ item.adresse }}</p>
                                        </td>
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ item.email }}</p>
                                        </td>
                                        <td>
                                            <p class="text-15 font-weight-medium">{{ item.telephone }}</p>
                                        </td>
                                        <td class="text-right">
                                            <v-btn @click="deleteClient(item.id)" color="primary" variant="outlined" class="mr-2">Supprimer</v-btn>
                                        </td>
                                    </tr>
                                </tbody>
                            </v-table>
                            <div class="container-loader">
                                <div v-if="loading" class="loader"></div>
                            </div>
                        </v-card-item>
                    </v-card>
                </v-col>
            </v-row>
        </v-col>
    </v-row>
</template>

<style scoped>
    .container-loader{
        display: flex;
        justify-content: center;
        align-items: center;
        width: 100%;
    }
    .loader {
        position: relative;
        width: 50px;
        height: 50px;
        border: 3px solid rgb(255,111,0);
        border-radius: 50%;
        border-top-color: transparent;
        animation: spin 1s linear infinite;
        margin: auto auto;
    }
    @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
    }
</style>